## Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2004, 2005,
##               2006, 2007 John W. Eaton
##
## This file is part of Octave.
##
## Octave is free software; you can redistribute it and/or modify it
## under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or (at
## your option) any later version.
##
## Octave is distributed in the hope that it will be useful, but
## WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
## General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with Octave; see the file COPYING.  If not, see
## <http://www.gnu.org/licenses/>.

## -*- texinfo -*-
 ## @deftypefn  {Function File} {@var{x} =} sortByNorm(@var{matrix})
## 
## sort a matrix  by the norm of its rows.
## @seealso{rrgb2ind2}
## @end deftypefn


## Author: Mike Zielinski <mikez23@aol.com>


function sorted=sortByNorm(A)
  if(nargin!=1)
    print_usage();
  endif
  toBeSorted=[];
  for i1=1:size(A,1)
	  toBeSorted(i1,1)=i1;
          toBeSorted(i1,2)=norm(A(i1,:),"fro");
  endfor
  
  [s,indices]=sort(toBeSorted(:,2));
  sortedNorms=toBeSorted(indices,:);
changedA=A;
for i2=1:size(A,1)
	 changedA(i2,:)=A(sortedNorms(i2,1),:);
endfor
sorted=changedA;
endfunction
